Index: src/Formula.cpp
===================================================================
--- src/Formula.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Formula.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * Formula.cpp
@@ -6,4 +13,11 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
 #include "Formula.hpp"
 
@@ -47,5 +61,5 @@
   for(const_iterator iter=end();iter!=begin();){
     --iter;
-    sstr << (*iter).first->symbol;
+    sstr << (*iter).first->getSymbol();
     if((*iter).second>1)
       sstr << (*iter).second;
@@ -55,12 +69,44 @@
 
 void Formula::fromString(const std::string &formula) throw(ParseError){
+  // make this transactional, in case an error is thrown
+  Formula res;
+  string::const_iterator begin = formula.begin();
+  string::const_iterator end = formula.end();
+  res.parseFromString(begin,end,static_cast<char>(0));
+  (*this)=res;
+}
+
+int Formula::parseMaybeNumber(string::const_iterator &it,string::const_iterator &end) throw(ParseError){
+  static const range<char> Numbers = makeRange('0',static_cast<char>('9'+1));
+  int count = 0;
+  while(it!=end && Numbers.isInRange(*it))
+    count = (count*10) + ((*it++)-Numbers.first);
+  // one is implicit
+  count = (count!=0)?count:1;
+  return count;
+}
+
+void Formula::parseFromString(string::const_iterator &it,string::const_iterator &end,char delimiter) throw(ParseError){
   // some constants needed for parsing... Assumes ASCII, change if other encodings are used
   static const range<char> CapitalLetters = makeRange('A',static_cast<char>('Z'+1));
   static const range<char> SmallLetters = makeRange('a',static_cast<char>('z'+1));
-  static const range<char> Numbers = makeRange('0',static_cast<char>('9'+1));
+  map<char,char> delimiters;
+  delimiters['('] = ')';
+  delimiters['['] = ']';
   // clean the formula
   clear();
-  string::const_iterator end = formula.end(); // will be used frequently
-  for(string::const_iterator it=formula.begin();it!=end;){
+  for(/*send from above*/;it!=end && *it!=delimiter;/*updated in loop*/){
+    // we might have a sub formula
+    if(delimiters.count(*it)){
+      Formula sub;
+      char nextdelim=delimiters[*it];
+      sub.parseFromString(++it,end,nextdelim);
+      if(!sub.getElementCount()){
+        throw(ParseError(__FILE__,__LINE__));
+      }
+      int count = parseMaybeNumber(++it,end);
+      addFormula(sub,count);
+      continue;
+    }
     string shorthand;
     // Atom names start with a capital letter
@@ -71,10 +117,5 @@
     while(it!=end && SmallLetters.isInRange(*it))
       shorthand+=(*it++);
-    // now we can count the occurences
-    int count = 0;
-    while(it!=end && Numbers.isInRange(*it))
-      count = (count*10) + ((*it++)-Numbers.first);
-    // one is implicit
-    count = (count!=0)?count:1;
+    int count = parseMaybeNumber(it,end);
     // test if the shorthand exists
     if(!World::getInstance().getPeriode()->FindElement(shorthand))
@@ -83,4 +124,7 @@
     addElements(shorthand,count);
   }
+  if(it==end && delimiter!=0){
+    throw(ParseError(__FILE__,__LINE__));
+  }
 }
 
@@ -93,5 +137,4 @@
     *output << "#Ion_TypeNr.\tAmount\tZ\tRGauss\tL_Max(PP)L_Loc(PP)IonMass\t# chemical name, symbol" << endl;
     for(const_iterator iter=begin(); iter!=end();++iter){
-      (*iter).first->No = No;
       result = result && (*iter).first->Checkout(output, No++, (*iter).second);
     }
@@ -117,5 +160,5 @@
 
 bool Formula::hasElement(const string &shorthand) const{
-  element * element = World::getInstance().getPeriode()->FindElement(shorthand);
+  const element * element = World::getInstance().getPeriode()->FindElement(shorthand);
   return hasElement(element);
 }
@@ -138,5 +181,5 @@
 
 void Formula::operator+=(const string &shorthand){
-  element * element = World::getInstance().getPeriode()->FindElement(shorthand);
+  const element * element = World::getInstance().getPeriode()->FindElement(shorthand);
   operator+=(element);
 }
@@ -169,5 +212,5 @@
 
 void Formula::operator-=(const string &shorthand){
-  element * element = World::getInstance().getPeriode()->FindElement(shorthand);
+  const element * element = World::getInstance().getPeriode()->FindElement(shorthand);
   operator-=(element);
 }
@@ -191,6 +234,20 @@
 
 void Formula::addElements(const string &shorthand,unsigned int count){
-  element * element = World::getInstance().getPeriode()->FindElement(shorthand);
+  const element * element = World::getInstance().getPeriode()->FindElement(shorthand);
   addElements(element,count);
+}
+
+void Formula::addFormula(const Formula &formula,unsigned int n){
+  for(Formula::const_iterator iter=formula.begin();iter!=formula.end();++iter){
+    this->addElements(iter->first,iter->second*n);
+  }
+}
+
+enumeration<Formula::key_type> Formula::enumerateElements() const{
+  enumeration<key_type> res(1);
+  for(Formula::const_iterator iter=begin();iter!=end();++iter){
+    res.add(iter->first);
+  }
+  return res;
 }
 
@@ -209,5 +266,5 @@
 
 const unsigned int Formula::operator[](string shorthand) const{
-  element * element = World::getInstance().getPeriode()->FindElement(shorthand);
+  const element * element = World::getInstance().getPeriode()->FindElement(shorthand);
   return operator[](element);
 }
@@ -337,5 +394,5 @@
 result_type
 Formula::_iterator<result_type>::operator*(){
-  element *element = World::getInstance().getPeriode()->FindElement(pos+1);
+  const element *element = World::getInstance().getPeriode()->FindElement(pos+1);
   ASSERT(element,"Element with position of iterator not found");
   return make_pair(element,(*set)[pos]);
@@ -347,5 +404,5 @@
   // no one can keep this value around, so a static is ok to avoid temporaries
   static value_type value=make_pair(reinterpret_cast<element*>(0),0); // no default constructor for std::pair
-  element *element = World::getInstance().getPeriode()->FindElement(pos+1);
+  const element *element = World::getInstance().getPeriode()->FindElement(pos+1);
   ASSERT(element,"Element with position of iterator not found");
   value = make_pair(element,(*set)[pos]);
Index: src/Formula.hpp
===================================================================
--- src/Formula.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Formula.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -16,4 +16,5 @@
 
 #include "types.hpp"
+#include "Helpers/helpers.hpp"
 
 class element;
@@ -22,5 +23,5 @@
 {
 public:
-  typedef element*                                      key_type;
+  typedef const element*                                key_type;
   typedef unsigned int                                  mapped_type;
   typedef std::pair<key_type, mapped_type>              value_type;
@@ -65,23 +66,27 @@
 
   unsigned int getElementCount() const;
-  bool hasElement(const element*)       const;
+  bool hasElement(key_type)             const;
   bool hasElement(atomicNumber_t)       const;
   bool hasElement(const std::string&)   const;
 
-  void operator+=(const element*);
+  void operator+=(key_type);
   void operator+=(atomicNumber_t);
   void operator+=(const std::string&);
 
-  void operator-=(const element*);
+  void operator-=(key_type);
   void operator-=(atomicNumber_t);
   void operator-=(const std::string&);
 
-  void addElements(const element*,unsigned int);
+  void addElements(key_type,unsigned int);
   void addElements(atomicNumber_t,unsigned int);
   void addElements(const std::string&,unsigned int);
 
+  void addFormula(const Formula&,unsigned int);
+
+  enumeration<key_type> enumerateElements() const;
+
   // only const versions, because someone might try to increment a previously
   // not set element
-  const unsigned int operator[](const element*) const;
+  const unsigned int operator[](key_type) const;
   const unsigned int operator[](atomicNumber_t) const;
   const unsigned int operator[](std::string)    const;
@@ -98,4 +103,6 @@
 
 private:
+  void parseFromString(std::string::const_iterator&,std::string::const_iterator&,char) throw(ParseError);
+  int parseMaybeNumber(std::string::const_iterator &it,std::string::const_iterator &end) throw(ParseError);
   // this contains all counts of elements in the formula
   // the size of the actual structure might be used in comparisons
Index: src/Helpers/Assert.cpp
===================================================================
--- src/Helpers/Assert.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Helpers/Assert.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * Assert.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -46,55 +58,125 @@
 }
 
-using namespace Assert;
-
 #ifndef NDEBUG
 
-Action _my_assert::defaultAction = Ask;
-std::vector<Assert::hook_t> _my_assert::hooks;
-
-std::map<std::string,bool> _wrapper::ignores;
-const char* _wrapper::message_ptr = "source pointer did not point to object of desired type";
-const char* _wrapper::message_ref = "source reference did not contain object of desired type";
-
-
-bool _my_assert::check(const bool res,
-                       const char* condition,
-                       const char* message,
-                       const char* filename,
-                       const int line,
-                       bool& ignore)
+#ifdef __GNUC__
+#include <cstdlib>
+#include <execinfo.h>
+#include <cxxabi.h>
+#endif
+
+Assert::Action Assert::_my_assert::defaultAction = Ask;
+std::vector<Assert::hook_t> Assert::_my_assert::hooks;
+
+std::map<std::string,bool> Assert::_wrapper::ignores;
+const char* Assert::_wrapper::message_ptr = "source pointer did not point to object of desired type";
+const char* Assert::_wrapper::message_ref = "source reference did not contain object of desired type";
+
+bool Assert::_my_assert::check(const char* condition,
+                               const char* message,
+                               const char* filename,
+                               const int line,
+                               bool& ignore)
 {
-  if(!res){
-    cout << "Assertion \"" << condition << "\" failed in file " << filename << " at line " << line << endl;
-    cout << "Assertion Message: " << message << std::endl;
-    while(true){
-      char choice;
-      if(defaultAction==Ask) {
-        cout << "Please choose: (a)bort, (t)hrow execption, (i)gnore, al(w)ays ignore" << endl;
-        cin >> choice;
+  cout << "Assertion \"" << condition << "\" failed in file " << filename << " at line " << line << endl;
+  cout << "Assertion Message: " << message << std::endl;
+  while(true){
+    char choice;
+    if(defaultAction==Assert::Ask) {
+#ifdef __GNUC__
+      cout << "Please choose: (a)bort, (t)hrow execption, show (b)actrace, (i)gnore, al(w)ays ignore" << endl;
+#else
+      cout << "Please choose: (a)bort, (t)hrow execption, (i)gnore, al(w)ays ignore" << endl;
+#endif /* __GNUC__ */
+      cin >> choice;
+    }
+    else{
+      choice = ActionKeys[defaultAction];
+    }
+    switch(choice){
+      case 'a':
+        return true;
+        break;
+      case 't':
+        throw AssertionFailure(condition,filename,line,message);
+        break;
+#ifdef __GNUC__
+      case 'b':
+        Assert::_my_assert::backtrace(filename,line);
+       break;
+#endif /* __GNUC__ */
+      case 'w':
+        ignore = true;
+        // fallthrough
+      case 'i':
+        return false;
+        break;
+    }
+  }
+  return false;
+}
+
+#ifdef __GNUC__
+void Assert::_my_assert::backtrace(const char *file, int line){
+  const size_t max_depth = 100;
+  void* stack_addrs[max_depth];
+  size_t stack_depth;
+  char **stack_strings=0;
+  const char *func_name=0;
+  size_t sz = 64;
+
+  // get the backtrace
+  stack_depth   = ::backtrace(stack_addrs,max_depth);
+  stack_strings = backtrace_symbols(stack_addrs, stack_depth);
+  // used later for demangling
+  // reserved here, so we can free it unconditionally
+  char *dm_function = static_cast<char*>(malloc(sz));
+  if(!dm_function){
+    // malloc failed... we are out of luck
+    cout << "cannot provide stack trace due to exhausted memory" << endl;
+    return;
+  }
+
+  cout << "Backtrace from  " << file << "@" << line << ":" << endl;
+
+  // i=2 because we don't want this function, nor the assertion handler
+  for(unsigned int i=2;i<stack_depth-2;++i){
+    // find the mangled function name
+    char *begin = stack_strings[i];
+    // function name starts with a (
+    while(*begin && *begin!='(') ++begin;
+    char *end=begin;
+    while(*end && *end!='+') ++end;
+
+    // see if we found our function name
+    if(*begin && *end){
+      *begin++ = 0;
+      *end = 0;
+      // use the C++ demangler
+
+      int status;
+      char *func_ret = abi::__cxa_demangle(begin, dm_function, &sz, &status);
+      if(func_ret){
+        // abi might have realloced...
+        dm_function = func_ret;
+        func_name = dm_function;
       }
       else{
-        choice = ActionKeys[defaultAction];
+        // demangling failed... get the function name without demangling
+        func_name = begin;
       }
-      switch(choice){
-        case 'a':
-          return true;
-          break;
-        case 't':
-          throw AssertionFailure(condition,filename,line,message);
-          break;
-        case 'w':
-          ignore = true;
-          // fallthrough
-        case 'i':
-          return false;
-          break;
-      }
-    }
-  }
-  return false;
-}
-
-void _my_assert::doHooks(){
+    }
+    else{
+      // function name not found... get the whole line
+      func_name = stack_strings[i];
+    }
+    cout << func_name << endl;
+  }
+  free(dm_function);
+  free(stack_strings); // malloc()ed by backtrace_symbols
+}
+#endif /* __GNUC__ */
+
+void Assert::_my_assert::doHooks(){
   for(vector<hook_t>::reverse_iterator iter = hooks.rbegin(); iter!=hooks.rend(); ++iter ){
     (*iter)();
@@ -102,9 +184,9 @@
 }
 
-void _my_assert::addHook(hook_t hook){
+void Assert::_my_assert::addHook(hook_t hook){
   hooks.push_back(hook);
 }
 
-void _my_assert::removeHook(Assert::hook_t hook){
+void Assert::_my_assert::removeHook(Assert::hook_t hook){
   for(vector<hook_t>::iterator iter = hooks.begin(); iter!=hooks.end();){
     if((*iter)==hook){
@@ -117,11 +199,11 @@
 }
 
-void _my_assert::setDefault(Assert::Action action){
+void Assert::_my_assert::setDefault(Assert::Action action){
   defaultAction = action;
 }
-Assert::Action _my_assert::getDefault(){
+Assert::Action Assert::_my_assert::getDefault(){
   return defaultAction;
 }
-std::string _my_assert::printDefault(){
+std::string Assert::_my_assert::printDefault(){
   return ActionNames[defaultAction];
 }
Index: src/Helpers/Assert.hpp
===================================================================
--- src/Helpers/Assert.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Helpers/Assert.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -234,6 +234,6 @@
       static bool ignore = false;\
       if(!ignore){\
-        if(Assert::_my_assert::check((condition),STRINGIFY(condition),(message),\
-                                     __FILE__,__LINE__,ignore)){\
+        if(!(condition) && Assert::_my_assert::check(STRINGIFY(condition),(message),\
+                                                     __FILE__,__LINE__,ignore)){\
           Assert::_my_assert::doHooks();\
           DEBUG_BREAK;\
@@ -247,7 +247,7 @@
 		  static bool ignore = false; \
 		  if(!ignore){\
-			  if(Assert::_my_assert::check(false,"Exception caught",(message),__FILE__,__LINE__,ignore)){\
+			  if(Assert::_my_assert::check("Exception caught",(message),__FILE__,__LINE__,ignore)){\
 			    Assert::_my_assert::doHooks();\
-          DEBUG_BREAK;\
+                            DEBUG_BREAK;\
 			  }\
 		  }\
@@ -299,10 +299,12 @@
     class _my_assert{
     public:
-      static bool check(const bool res,
-                        const char* condition,
+      static bool check(const char* condition,
                         const char* message,
                         const char* filename,
                         const int line,
                         bool& ignore);
+#ifdef __GNUC__
+      static void backtrace(const char *file, int line);
+#endif /* __GNUC__ */
       static void addHook(Assert::hook_t hook);
       static void removeHook(Assert::hook_t hook);
@@ -332,6 +334,6 @@
 
       if(!ignore){
-        if(_my_assert::check(dynamic_cast<target>(src)==static_cast<target>(src),"type-safe typecast",
-                                       message_ptr,file,line,ignore)){
+        bool res = dynamic_cast<target>(src)==static_cast<target>(src);
+        if(!res && _my_assert::check("type-safe typecast",message_ptr,file,line,ignore)){
           _my_assert::doHooks();
           DEBUG_BREAK;
@@ -354,5 +356,5 @@
       catch(...){
         if(!ignore){
-          if(_my_assert::check(0,"type-safe typecast",message_ref,file,line,ignore)){
+          if(_my_assert::check("type-safe typecast",message_ref,file,line,ignore)){
             _my_assert::doHooks();
             DEBUG_BREAK;
Index: src/Helpers/Info.cpp
===================================================================
--- src/Helpers/Info.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Helpers/Info.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,55 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * Info.cpp
+ *
+ *  Created on: Nov 25, 2009
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Helpers/Info.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+
+int Info::verbosity = 0;
+
+/**
+ * Constructor. Do not use this function. Use getInstance() instead.
+ *
+ * \return Info instance
+ */
+Info::Info(const char *msg) :
+  FunctionName(msg)
+{
+  verbosity++;
+  DoLog(0) && (Log() << Verbose(0) << "Begin of " << FunctionName << endl);
+};
+
+/**
+ * Destructor. Better use purgeInstance().
+ */
+Info::~Info() {
+  DoLog(0) && (Log() << Verbose(0) << "End of " << FunctionName << endl);
+  verbosity--;
+}
+
+/**
+ * Sets the verbosity.
+ *
+ * \param verbosityLevel verbosity
+ */
+void Info::setVerbosity(int verbosityLevel) {
+  verbosity = verbosityLevel;
+}
Index: src/Helpers/Info.hpp
===================================================================
--- src/Helpers/Info.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Helpers/Info.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,30 @@
+/*
+ * Info.hpp
+ *
+ *  Created on: Nov 25, 2009
+ *      Author: heber
+ */
+
+#ifndef INFO_HPP_
+#define INFO_HPP_
+
+using namespace std;
+
+/*********************************************** includes ***********************************/
+
+/****************************************** forward declarations *****************************/
+
+/********************************************** definitions *********************************/
+
+class Info {
+public :
+  static int verbosity;
+  const char *FunctionName;
+
+  Info(const char *msg);
+  ~Info();
+  static void setVerbosity(int verbosityLevel);
+
+};
+
+#endif /* INFO_HPP_ */
Index: src/Helpers/Log.cpp
===================================================================
--- src/Helpers/Log.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Helpers/Log.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,81 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * log.cpp
+ *
+ *  Created on: Oct 19, 2009
+ *      Author: metzler
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Helpers/logger.hpp"
+#include "Helpers/errorlogger.hpp"
+
+/**
+ * Sets verbosity for the error logger and the standard logger.
+ *
+ * \param int verbosity level
+ */
+void setVerbosity(int verbosityLevel) {
+  logger::getInstance().setVerbosity(verbosityLevel);
+}
+
+/**
+ * Gets verbosity for the error logger and the standard logger.
+ *
+ * \param int verbosity level
+ */
+int getVerbosity() {
+  return logger::getInstance().getVerbosity();
+}
+
+/**
+ * Prints a log entry.
+ *
+ * \param indentation level of the message to log
+ */
+class logger& Log() {
+  return logger::getInstance();
+}
+
+/** Checks verbosity for logger.
+ * Is supposed to be used in construct as this:
+ * DoLog(2) && (Log() << Verbose(2) << "message." << endl);
+ * If DoLog does not return true, the right-hand side is not evaluated and we save some time.
+ * \param verbose verbosity level of this message
+ * \return true - print, false - don't
+ */
+bool DoLog(int verbose) {
+  return (verbose <= logger::getInstance().verbosity);
+}
+
+/** Checks verbosity for errorlogger.
+ * Is supposed to be used in construct as this:
+ * DoLog(2) && (Log() << Verbose(2) << "message." << endl);
+ * If DoLog does not return true, the right-hand side is not evaluated and we save some time.
+ * \param verbose verbosity level of this message
+ * \return true - print, false - don't
+ */
+bool DoeLog(int verbose) {
+  return (verbose <= errorLogger::getInstance().verbosity);
+}
+
+/**
+ * Prints an error log entry.
+ *
+ * \param indentation level of the message to log
+ */
+class errorLogger & eLog() {
+  return errorLogger::getInstance();
+}
Index: src/Helpers/Log.hpp
===================================================================
--- src/Helpers/Log.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Helpers/Log.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,21 @@
+/*
+ * log.hpp
+ *
+ *  Created on: Oct 19, 2009
+ *      Author: metzler
+ */
+
+#ifndef LOG_HPP_
+#define LOG_HPP_
+
+#include "Helpers/errorlogger.hpp"
+#include "Helpers/logger.hpp"
+
+class logger & Log();
+class errorLogger & eLog();
+void setVerbosity(int verbosityLevel);
+int getVerbosity();
+bool DoLog(int verbose);
+bool DoeLog(int verbose);
+
+#endif /* LOG_HPP_ */
Index: src/Helpers/Makefile.am
===================================================================
--- src/Helpers/Makefile.am	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Helpers/Makefile.am	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,79 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
+INCLUDES = -I$(top_srcdir)/src
+
+AM_LDFLAGS = $(CPPUNIT_LIBS) -ldl
+# Position-Independent Code necessary for shared library
+AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
+
+# this includes source files that need to be present at multiple points
+HELPERSSOURCE =  \
+  Assert.cpp \
+  errorlogger.cpp \
+  helpers.cpp \
+  Info.cpp \
+  Log.cpp \
+  logger.cpp \
+  MemDebug.cpp \
+  Verbose.cpp
+
+HELPERSHEADER =  \
+  Assert.hpp \
+  errorlogger.hpp \
+  helpers.hpp \
+  Info.hpp \
+  Log.hpp \
+  logger.hpp \
+  MemDebug.hpp \
+  Verbose.hpp
+
+lib_LTLIBRARIES = libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la
+libMolecuilderHelpers_includedir = $(includedir)/molecuilder-$(MOLECUILDER_API_VERSION)/Actions/
+nobase_libMolecuilderHelpers_include_HEADERS = ${HELPERSHEADER}
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libMolecuilderHelpers_@MOLECUILDER_API_VERSION@_la_SOURCES = ${HELPERSSOURCE}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+libMolecuilderHelpers_@MOLECUILDER_API_VERSION@_la_LDFLAGS = -version-info $(MOLECUILDER_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+libMolecuilderHelpers_libincludedir = $(libdir)/molecuilder-$(MOLECUILDER_API_VERSION)/include
+nodist_libMolecuilderHelpers_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
+
+## Install the generated pkg-config file (.pc) into the expected location for
+## architecture-dependent package configuration information.  Occasionally,
+## pkg-config files are also used for architecture-independent data packages,
+## in which case the correct install location would be $(datadir)/pkgconfig.
+pkgconfigdir = $(libdir)/pkgconfig
+pkgconfig_DATA = $(top_builddir)/molecuilder-$(MOLECUILDER_API_VERSION).pc
+
+unity.cpp:
+	echo "" >  unity.cpp; \
+	list='$(HELPERSSOURCE)'; for file in $$list; do \
+	  if [ "$$file" != "MemDebug.cpp" ]; then \
+		  echo "#include \"$(srcdir)/$$file\"" >> unity.cpp; \
+	 	fi; \
+	done;
+	
+MOSTLYCLEANFILES = unity.cpp
Index: src/Helpers/MemDebug.cpp
===================================================================
--- src/Helpers/MemDebug.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Helpers/MemDebug.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * MemDebug.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 // NDEBUG implies NO_MEMDEBUG
@@ -72,4 +84,5 @@
   // all allocated memory blocks
   struct entry_t {
+    typedef unsigned int checksum_t;
     // we seperate the tracking info from the rest
     // A checksum will be calculated for this part of
@@ -90,5 +103,5 @@
     } info;
     bool isIgnored;
-    char checksum;
+    checksum_t checksum;
     entry_t *prev;
     entry_t *next;
@@ -117,7 +130,7 @@
   // calculates a simple checksum for the info block
   // the checksum is used to find memory corruptions
-  inline char calcChecksum(entry_t::info_t *info){
+  inline entry_t::checksum_t calcChecksum(entry_t::info_t *info){
     char *buffer = (char*)info;
-    char checksum =0;
+    entry_t::checksum_t checksum =0;
     for(size_t i=0;i<sizeof(entry_t::info_t);i++){
       checksum+=buffer[i];
@@ -154,4 +167,32 @@
       cout << "Chunk reserved at: " << pos->info.file << ":" << pos->info.line << endl;
 #endif
+    }
+  }
+
+  void dumpMemory(std::ostream &ost){
+    ost << "Maximum allocated Memory: " << max << " bytes" << endl;
+    ost << "Maximum allocated Memory: " << max << " bytes" << endl;
+    ost << "Currently allocated Memory: " << state <<" bytes" << endl;
+    ost << allocs << " allocated chunks total" << endl;
+    bool corrupted=false;
+    for(entry_t *pos=begin;pos;pos=pos->next){
+      ost << "\nChunk of " << pos->info.nbytes << " bytes" << " still available" << endl;
+#     ifdef __GNUC__
+        ost << "Chunk reserved at: " << pos->info.function
+             << " (" << pos->info.file << ":" << pos->info.line  << ")" << endl;
+#     else
+        ost << "Chunk reserved at: " << pos->info.file << ":" << pos->info.line << endl;
+#     endif
+        ost << "Chunk address: " << pos->info.location << endl;
+        entry_t::checksum_t checksum = calcChecksum(&pos->info);
+        ost << "Checksum of chunk: " << checksum << endl;
+        ost << "Checksum at allocation time: " << pos->checksum << endl;
+        if(checksum!=pos->checksum){
+          ost << "!!!Chunk was corrupted!!!" << endl;
+          corrupted=true;
+        }
+    }
+    if(corrupted){
+      ost << "\n!!!Memory corruption detected!!!" << endl;
     }
   }
Index: src/Helpers/MemDebug.hpp
===================================================================
--- src/Helpers/MemDebug.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Helpers/MemDebug.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -61,4 +61,5 @@
    */
   void getState();
+  void dumpMemory(std::ostream&);
 
   void _ignore(void*);
@@ -100,8 +101,13 @@
 
 #else
+
+#include <iosfwd>
+
 // memory debugging was disabled
 
 namespace Memory {
-  inline void getState(){}
+  inline void getState(){};
+
+  inline void dumpMemory(std::ostream&){};
 
   template <typename T>
